﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;

namespace baryonswp
{
    public partial class Form1 : Form
    {
        private static Thread serviceThread;
        private bool running = false;

        public Form1()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
            Program.frm1 = this;
            this.Load += Form1_Load;
            button2.Enabled = false;
        }
        
        void Form1_Load(object sender, EventArgs e)
        {
            var ports = System.IO.Ports.SerialPort.GetPortNames();
            comboBox1.DataSource = ports;
        }
        
        public void LogToTextbox(string msg)
        {
            richTextBox1.Text += (msg+"\n");
            richTextBox1.SelectionStart = richTextBox1.TextLength;
            richTextBox1.ScrollToCaret();
        }
       /* public void LogToCMTextbox(byte combyte)
        {
            richTextBox2.Text += combyte.ToString("X2");
            richTextBox2.SelectionStart = richTextBox2.TextLength;
            richTextBox2.ScrollToCaret();
        }*/
        public void LogToTextboxIfDebugEnabled (string msg)
        {
            if (checkBox1.Checked) LogToTextbox(msg); 
        }
        public void KeyLogToTextbox(string msg)
        {
            if (checkBox2.Checked) LogToTextbox(msg);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            string serial = String.Empty;
            if (radioButton1.Checked) serial = "FFFFFFFF";
            if (radioButton2.Checked) serial = "00000000";
            if (radioButton3.Checked) serial = textBox1.Text;
            if (radioButton4.Checked) serial = "12345678";
            if (!radioButton4.Checked && !radioButton3.Checked && !radioButton2.Checked
                && !radioButton1.Checked) { LogToTextbox("Please select the emulated battery mode."); return; }
            if (running) { LogToTextbox("Service is already running."); return; }
            if (comboBox1.Text == String.Empty) { LogToTextbox("No port specified."); return; }
            if (radioButton3.Checked && !(textBox1.TextLength == 8) && !running) { LogToTextbox("Serial number must be 8 characters long."); return; }
            
            serviceThread = new Thread(() => Program.StartSerialEmulation(comboBox1.Text, serial));
            checkBox1.Enabled = false;
            checkBox2.Enabled = false;
            button1.Enabled = false;
            button2.Enabled = true;
            button3.Enabled = false;
            button4.Enabled = false;
            comboBox1.Enabled = false;
            button6.Enabled = false;
			textBox1.Enabled = false;
            label1.Enabled = false;
            label2.Enabled = false;
            radioButton1.Enabled = false;
            radioButton2.Enabled = false;
            radioButton3.Enabled = false;
            radioButton4.Enabled = false;
            running = true;
            
            serviceThread.Start();
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (!running) return;
            LogToTextbox("Killing the service...");
            try { Program.serialPortInstance.Close(); }
            catch { LogToTextbox("WTF? Unable to kill! Something is super weird with the port, try again or restart the application..."); return; }
            running = false;
            checkBox1.Enabled = true;
            button1.Enabled = true;
            checkBox2.Enabled = true;
            button2.Enabled = false;
            button3.Enabled = true;
            button4.Enabled = true;
            comboBox1.Enabled = true;
            button6.Enabled = true;
            textBox1.Enabled = true;
            label2.Enabled = true;
            label1.Enabled = true;
            radioButton1.Enabled = true;
            radioButton2.Enabled = true;
            radioButton3.Enabled = true;
            radioButton4.Enabled = true;
        }



        private void button6_Click(object sender, EventArgs e)
        {
            var ports = System.IO.Ports.SerialPort.GetPortNames();
            comboBox1.DataSource = ports;
        }


		private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
		{
            char c = e.KeyChar;
            if (textBox1.Text.Length >= 8) { e.Handled = true; return; }
            if (c >= 'a' && c <= 'f')
            {
                textBox1.Text += Char.ToUpper(c);
                e.Handled = true;
            } 
            else if (!((c >= '0' && c <= '9') || (c >= 'A' && c <= 'F')))
            {
                e.Handled = true;
            }
		}

		private void button5_Click(object sender, EventArgs e)
		{
            richTextBox1.Clear();
		}

		private void button3_Click(object sender, EventArgs e)
		{
            richTextBox1.Clear();
            LogToTextbox("Please refer to PSPx / psx-place threads to restore your PSP™.");
            LogToTextbox("\nhttps://www.pspx.ru/forum/showthread.php?p=1229948 (Russian, frequently updated)");
            LogToTextbox("\nhttps://www.psx-place.com/threads/baryon-sweeper-r1-release-unbrick-1000-2000-and-3000-psp-consoles.32503/ \n(English, less frequent updates)");
		}

		private void button4_Click(object sender, EventArgs e)
		{
            richTextBox1.Clear();
            LogToTextbox("BaryonSweeper - a JigKick internal service tool emulator");
            LogToTextbox("Brought to you by patience and perserverance of:\n");
            LogToTextbox("M4j0r - Syscon Voltage Fault Injection glitch help\n");
            LogToTextbox("Wildcard - Syscon glitching and dumping\n");
            LogToTextbox("Proxima - Firmware reverse engineering, battery authentication response generator script\n");
            LogToTextbox("khubik - Emulator code, GUI design, authentication script porting\n");
            LogToTextbox("dogecore - Authentication script porting, GUI code, emulator threading fix\n");
            LogToTextbox("Mathieu Hervais - decrypt-sp & decrypt-OS2 homebrew code\n");
            LogToTextbox("SSL/Zerotolerance - re-encryption for Math's homebrews\n");
            LogToTextbox("zecoxao - decrypt-sp & decrypt-os2 PC ports, boards supply, authentication script porting help\n");
            LogToTextbox("Yoti - decrypt-sp improvements, MSID Dumper, contribution to PSPx.ru's 3000 series JigKick hacking thread, PSP 3000 supplier (<3), PSP 3000 unbrick PoC\n");
            LogToTextbox("ErikPshat - Useful intel about JigKick, PSPx.ru's 3000 series JigKick hacking thread contribution, creation of functional JigKick memcard clone from original dump, userguides for MSID dumping and JigKick memory card creation\n");
            LogToTextbox("Boryan, lport3, dx3d and many others from PSPx.ru's 3000 JigKick hacking thread - battery communication dumps and protocol reversal, one wire UART adapter schematics and more!\n");
            LogToTextbox("lolivera - PSP 3000 unbrick PoC, TA-095 testing\n");
            LogToTextbox("Sean Shablack aka Kyp40 aka FBIsoBOT - Syscon glitching and dumping, simplest one wire UART adapter schematic ever\n");
			LogToTextbox("预见 (zakezzzz) - TA-092 testing\n");
            LogToTextbox("dee008 - Portable PSP battery controller emulator, PSP Street K-line pin location\n");
            LogToTextbox("[!] Please do note that this tool is free and open-source. If you paid for it, demand a refund in full.\n");


            richTextBox1.SelectionStart = 0;
            richTextBox1.ScrollToCaret();
        }
		/*private void button7_Click(object sender, EventArgs e)
		{
            richTextBox2.Clear();
		}*/
	}
}
