﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Security.Cryptography;
using System.Runtime.InteropServices;
using Microsoft.Win32.SafeHandles;
using System.IO;
using System.Text;
using System.Runtime;

namespace baryonswp
{
    static class Program
    {
        [DllImport("kernel32.dll")]
        static extern bool AttachConsole(int dwProcessId);
        private const int ATTACH_PARENT_PROCESS = -1;
        public static bool usingGui = false;
        public static Form1 frm1;
        public static SerialPort serialPortInstance = null;
        static byte[] msg;
        static byte[] response1a = new byte[8];
        static byte[] response1b = new byte[8]; // battery nonce
        static byte[] response2g = new byte[8];
        // OOH THE KEYS
        static readonly Dictionary<byte, byte[]> keystore = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[]     { 0x5C, 0x52, 0xD9, 0x1C, 0xF3, 0x82, 0xAC, 0xA4, 0x89, 0xD8, 0x81, 0x78, 0xEC, 0x16, 0x29, 0x7B } }, // FAT
            { 1, new byte[]     { 0x9D, 0x4F, 0x50, 0xFC, 0xE1, 0xB6, 0x8E, 0x12, 0x09, 0x30, 0x7D, 0xDB, 0xA6, 0xA5, 0xB5, 0xAA } }, // STOLEN FROM CHINESE PRODUCTION LINES LMAO
            { 2, new byte[]     { 0x09, 0x75, 0x98, 0x88, 0x64, 0xAC, 0xF7, 0x62, 0x1B, 0xC0, 0x90, 0x9D, 0xF0, 0xFC, 0xAB, 0xFF } }, // SLIM FALLBACK
            { 3, new byte[]     { 0xC9, 0x11, 0x5C, 0xE2, 0x06, 0x4A, 0x26, 0x86, 0xD8, 0xD6, 0xD9, 0xD0, 0x8C, 0xDE, 0x30, 0x59 } }, // STOLEN FROM CHINESE PRODUCTION LINES LMAO
            { 4, new byte[]     { 0x66, 0x75, 0x39, 0xD2, 0xFB, 0x42, 0x73, 0xB2, 0x90, 0x3F, 0xD7, 0xA3, 0x9E, 0xD2, 0xC6, 0x0C } }, // BRITE AUTOBOOT
            { 5, new byte[]     { 0xF4, 0xFA, 0xEF, 0x20, 0xF4, 0xDB, 0xAB, 0x31, 0xD1, 0x86, 0x74, 0xFD, 0x8F, 0x99, 0x05, 0x66 } }, // STOLEN FROM CHINESE PRODUCTION LINES LMAO
            { 6, new byte[]     { 0xEA, 0x0C, 0x81, 0x13, 0x63, 0xD7, 0xE9, 0x30, 0xF9, 0x61, 0x13, 0x5A, 0x4F, 0x35, 0x2D, 0xDC } }, // STOLEN FROM CHINESE PRODUCTION LINES LMAO
            { 8, new byte[]     { 0x0A, 0x2E, 0x73, 0x30, 0x5C, 0x38, 0x2D, 0x4F, 0x31, 0x0D, 0x0A, 0xED, 0x84, 0xA4, 0x18, 0x00 } }, // SLIM PRIMARY
            { 0xA, new byte[]   { 0xAC, 0x00, 0xC0, 0xE3, 0xE8, 0x0A, 0xF0, 0x68, 0x3F, 0xDD, 0x17, 0x45, 0x19, 0x45, 0x43, 0xBD } }, // TA-090V2 - TA-092 NORMAL
            { 0xD, new byte[]   { 0xDF, 0xF3, 0xFC, 0xD6, 0x08, 0xB0, 0x55, 0x97, 0xCF, 0x09, 0xA2, 0x3B, 0xD1, 0x7D, 0x3F, 0xD2 } }, // TA-093+ NORMAL
            { 0xD9, new byte[]  { 0xC7, 0xAC, 0x13, 0x06, 0xDE, 0xFE, 0x39, 0xEC, 0x83, 0xA1, 0x48, 0x3B, 0x0E, 0xE2, 0xEC, 0x89 } }  // TA-090V2 - TA-092 FSM
            };
        static readonly Dictionary<byte, byte[]> challenge1_secret = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[]     { 0xD2, 0x07, 0x22, 0x53, 0xA4, 0xF2, 0x74, 0x68 } },
            { 1, new byte[]     { 0xF5, 0xD7, 0xD4, 0xB5, 0x75, 0xF0, 0x8E, 0x4E } },
            { 2, new byte[]     { 0xB3, 0x7A, 0x16, 0xEF, 0x55, 0x7B, 0xD0, 0x89 } },
            { 3, new byte[]     { 0xCC, 0x69, 0x95, 0x81, 0xFD, 0x89, 0x12, 0x6C } },
            { 4, new byte[]     { 0xA0, 0x4E, 0x32, 0xBB, 0xA7, 0x13, 0x9E, 0x46 } },
            { 5, new byte[]     { 0x49, 0x5E, 0x03, 0x47, 0x94, 0x93, 0x1D, 0x7B } },
            { 6, new byte[]     { 0xB0, 0xB8, 0x09, 0x83, 0x39, 0x89, 0xFA, 0xE2 } },
            { 8, new byte[]     { 0xAD, 0x40, 0x43, 0xB2, 0x56, 0xEB, 0x45, 0x8B } },
            { 0xA, new byte[]   { 0xC2, 0x37, 0x7E, 0x8A, 0x74, 0x09, 0x6C, 0x5F } },
            { 0xD, new byte[]   { 0x58, 0x1C, 0x7F, 0x19, 0x44, 0xF9, 0x62, 0x62 } },
            { 0x2F, new byte[]  { 0xC9, 0xF8, 0x09, 0x45, 0x2A, 0xA2, 0xBE, 0xD5 } },
            { 0xD9, new byte[]  { 0x90, 0xE1, 0xF0, 0xC0, 0x01, 0x78, 0xE3, 0xFF } },
            { 0x97, new byte[]  { 0x66, 0x1A, 0x4D, 0x7F, 0x6E, 0xCD, 0x33, 0xC5 } }
            };
        static readonly Dictionary<byte, byte[]> challenge2_secret = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[]     { 0xF4, 0xE0, 0x43, 0x13, 0xAD, 0x2E, 0xB4, 0xDB } },
            { 1, new byte[]     { 0xFE, 0x7D, 0x78, 0x99, 0xBF, 0xEC, 0x47, 0xC5 } },
            { 2, new byte[]     { 0x86, 0x5E, 0x3E, 0xEF, 0x9D, 0xFB, 0xB1, 0xFD } },
            { 3, new byte[]     { 0x30, 0x6F, 0x3A, 0x03, 0xD8, 0x6C, 0xBE, 0xE4 } },
            { 4, new byte[]     { 0xFF, 0x72, 0xBD, 0x2B, 0x83, 0xB8, 0x9D, 0x2F } },
            { 5, new byte[]     { 0x84, 0x22, 0xDF, 0xEA, 0xE2, 0x1B, 0x63, 0xC2 } },
            { 6, new byte[]     { 0x58, 0xB9, 0x5A, 0xAE, 0xF3, 0x99, 0xDB, 0xD0 } },
            { 8, new byte[]     { 0x67, 0xC0, 0x72, 0x15, 0xD9, 0x6B, 0x39, 0xA1 } },
            { 0xA, new byte[]   { 0x09, 0x3E, 0xC5, 0x19, 0xAF, 0x0F, 0x50, 0x2D } },
            { 0xD, new byte[]   { 0x31, 0x80, 0x53, 0x87, 0x5C, 0x20, 0x3E, 0x24 } },
            { 0x2F, new byte[]  { 0x40, 0xD0, 0x2B, 0xAC, 0xFB, 0x1A, 0x8B, 0xEA } },
            { 0xD9, new byte[]  { 0xC3, 0x4A, 0x6A, 0x7B, 0x20, 0x5F, 0xE8, 0xF9 } },
            { 0x97, new byte[]  { 0x2B, 0xF5, 0xF2, 0x95, 0x86, 0xA7, 0x64, 0x48 } }
            };

        [STAThread]
        static void Main(string[] args)
        {
            AttachConsole(ATTACH_PARENT_PROCESS);
            Console.WriteLine("");
            if (args.Length == 0)
            {
                usingGui = true;
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new Form1());

            }
            else if (args.Length != 1)
            {
                UsageError(1);
            }
            else if (args.Length == 1)
            {
                string[] ports = SerialPort.GetPortNames();
                if (args[0] == "list")
                {
                    if (ports.Length == 0)
                    {
                        Console.WriteLine("No ports available.");

                    }
                    foreach (string port in ports)
                    {
                        Console.WriteLine(port);
                    }
                }
                else if (!ports.Contains(args[0]) && args[0].Contains("COM"))
                {
                    UsageError(2);
                }
                else if (ports.Contains(args[0]))
                {
                    Console.WriteLine("Input serial number (0-9 A-F), 8 symbols");
                    string serialstr = Console.ReadLine();
                    StartSerialEmulation(args[0], serialstr);
                }
                else UsageError(1);
            }

        }
        static void UsageError(int errNum)
        {
            switch (errNum)
            {
                case 1:
                    Console.WriteLine("Usage: baryonswp.exe <PSP(tm) COM port>");
                    Console.WriteLine("Alternatively, use 'baryonswp.exe list' to list available COM ports.");
                    break;
                case 2:
                    Console.WriteLine("Specified COM port does not exist!");
                    Console.WriteLine("Use 'baryonswp.exe list' to list available COM ports.");
                    break;
            }
        }
        static void debugLog(string msg)
        {
            if (!usingGui) Console.WriteLine(msg);
            else
            {
                frm1.LogToTextboxIfDebugEnabled(msg);
            }
        }
        static void log(string msg)
        {
            if (!usingGui) Console.WriteLine(msg);
            else
            {

                frm1.LogToTextbox(msg);
            }
        }
        static void KeyLog(string msg)
        {
            if (!usingGui) Console.WriteLine(msg);
            else frm1.KeyLogToTextbox(msg);

        }
    /*static void CMLog(byte combyte)
    {
            frm1.LogToCMTextbox(combyte);
    }*/
    public static void StartSerialEmulation(string portName, string serial)
        {
            serialPortInstance = new SerialPort(portName)
            {
                BaudRate = 19200,
                Parity = Parity.Even,
                StopBits = StopBits.One,
                DataBits = 8,
                Handshake = Handshake.None
            };
           
            log("Initialized port " + portName);

            try { serialPortInstance.Open(); }
            catch { log("Port is taken by another application or something is wrong with it. Try again."); return; }
            serialPortInstance.DiscardInBuffer();
            serialPortInstance.DiscardOutBuffer();
            if (serial.Length == 8) log("Using serial number " + serial);
            else { Console.WriteLine("Serial number must be 8 characters long."); serialPortInstance.Close(); return; }
            log("Service ready. Please connect your PSP™.");
            byte[] pspdata = new byte[4];
            byte[] bswpresponse = new byte[4];
            while (serialPortInstance.IsOpen)
            {
                try
                {
                    System.Threading.Thread.Sleep(1);
                    if (serialPortInstance.BytesToRead >= 4)
                    {
                        pspdata[0] = (byte)serialPortInstance.ReadByte();
                        if (pspdata[0] == 0x5A)
                        {
                            pspdata[1] = (byte)serialPortInstance.ReadByte();     // packet length
                            pspdata[2] = (byte)serialPortInstance.ReadByte();     // operation code
                            if (pspdata[1] == 0x02)                                                  // if packet has no message then byte after the opcode is the checksum
                            {
                                pspdata[3] = (byte)serialPortInstance.ReadByte();
                                log(BitConverter.ToString(pspdata).Replace("-", " "));
                            }
                            else  // packet contains a message
                            {
                                int msgLength = ((int)pspdata[1] - 2); // actual msg length (no opcode & csum)
                                while (serialPortInstance.BytesToRead < (int)pspdata[1] - 1) { System.Threading.Thread.Sleep(1); }; // wait until buffer has remaining msg and csum (opcode is already read so -1)
                                msg = new byte[msgLength];
                                for (int i = 0; i < msgLength; i++) msg[i] = (byte)serialPortInstance.ReadByte();
                                pspdata[3] = (byte)serialPortInstance.ReadByte();
                                byte[] h1 = new byte[3];
                                for (int i = 0; i < 3; i++) h1[i] = pspdata[i];
                                log(BitConverter.ToString(h1).Replace("-", " ") + " " + BitConverter.ToString(msg).Replace("-", "") + " " + pspdata[3].ToString("X2"));
                            }

                            switch (pspdata[2])
                            {
                                case 0x01:
                                    byte[] answer = new byte[] { 0xA5, 0x05, 0x06, 0x10, 0xC3, 0x06, 0x76 };
                                    byte[] h1 = new byte[3]; for (int i = 0; i < 3; i++) h1[i] = answer[i];
                                    for (int i = 0; i < answer.Length; i++)
                                    {
                                        serialPortInstance.Write(answer, i, 1);
                                    }
                                    break;
                                case 0x0c:
                                    byte[] headersn = new byte[] { 0xA5, 0x06, 0x06 };
                                    byte[] serialno = StringToByteArray(serial);
                                    byte[] tempsn = new byte[7];
                                    byte[] tempsnLE = new byte[4];
                                    int[] order = new int[4] { 1, 0, 3, 2 };
                                    for (int i = 0; i < 4; i++) tempsnLE[i] = serialno[order[i]];
                                    Array.Copy(headersn, tempsn, headersn.Length);
                                    Array.Copy(tempsnLE, 0, tempsn, 3, serialno.Length);
                                    byte[] tempsn1 = new byte[1];
                                    tempsn1[0] = GeneratePacketChecksum(tempsn);
                                    for (int i = 0; i < tempsn.Length; i++)
                                    {
                                        serialPortInstance.Write(tempsn, i, 1);
                                    }
                                    serialPortInstance.Write(tempsn1, 0, tempsn1.Length);
                                    break;
                                case 0x80:
                                    generateSysconResponses(msg);
                                    // create 19 byte long byte array  (a5 12 06 + bytes from response 1a + bytes from response 1b) and calculate
                                    // its checksum using GeneratePacketChecksum
                                    // send the array and checksum over serial
                                    byte[] header = new byte[3] { 0xA5, 0x12, 0x06 };
                                    byte[] temp = new byte[19];
                                    Array.Copy(header, temp, 3);
                                    Array.Copy(response1a, 0, temp, 3, response1a.Length);
                                    Array.Copy(response1b, 0, temp, (3 + response1a.Length), response1b.Length);
                                    byte[] temp111 = new byte[1];
                                    temp111[0] = GeneratePacketChecksum(temp);
                                    serialPortInstance.Write(temp, 0, temp.Length);
                                    serialPortInstance.Write(temp111, 0, temp111.Length);
                                    break;
                                case 0x81:
                                    byte[] header1 = new byte[3] { 0xA5, 0x0A, 0x06 };
                                    byte[] temp1 = new byte[11];
                                    byte[] cs1 = new byte[1];
                                    Array.Copy(header1, temp1, 3);
                                    Array.Copy(response2g, 0, temp1, 3, response2g.Length);
                                    cs1[0] = GeneratePacketChecksum(temp1);
                                    for (int i = 0; i < temp1.Length; i++)
                                    {
                                        serialPortInstance.Write(temp1, i, 1);
                                    }

                                    serialPortInstance.Write(cs1, 0, 1);
                                    break;
                                case 0x03:
                                    byte[] answer3 = new byte[] { 0xA5, 0x04, 0x06, 0x36, 0x10, 0x0A };
                                    for (int i = 0; i < answer3.Length; i++)
                                    {
                                        serialPortInstance.Write(answer3, i, 1);
                                    }
                                    break;
                                case 0x07:
                                    byte[] answer4 = new byte[] { 0xA5, 0x04, 0x06, 0x08, 0x07, 0x41 };
                                    for (int i = 0; i < answer4.Length; i++)
                                    {
                                        serialPortInstance.Write(answer4, i, 1);
                                    }
                                    break;
                                case 0x0B:
                                    byte[] answer5 = new byte[] { 0xA5, 0x04, 0x06, 0x0F, 0x00, 0x41 };
                                    for (int i = 0; i < answer5.Length; i++)
                                    {
                                        serialPortInstance.Write(answer5, i, 1);
                                    }
                                    break;
                                case 0x09:
                                    byte[] answer6 = new byte[] { 0xA5, 0x04, 0x06, 0x01, 0x04, 0x4B };
                                    for (int i = 0; i < answer6.Length; i++)
                                    {
                                        serialPortInstance.Write(answer6, i, 1);
                                    }
                                    break;
                                case 0x02:
                                    byte[] answer7 = new byte[] { 0xA5, 0x03, 0x06, 0x1B, 0x36 };
                                    for (int i = 0; i < answer7.Length; i++)
                                    {
                                        serialPortInstance.Write(answer7, i, 1);
                                    }
                                    break;
                                case 0x04:
                                    byte[] answer8 = new byte[] { 0xA5, 0x04, 0x06, 0x68, 0x10, 0xD8 };
                                    for (int i = 0; i < answer8.Length; i++)
                                    {
                                        serialPortInstance.Write(answer8, i, 1);
                                    }
                                    break;
                                case 0x16:
                                    byte[] answer9 = new byte[] { 0xA5, 0x13, 0x06, 0x53, 0x6F, 0x6E, 0x79, 0x45, 0x6E, 0x65, 0x72,
                                                                  0x67, 0x79, 0x44, 0x65, 0x76, 0x69, 0x63, 0x65, 0x73, 0x6B };
                                    for (int i = 0; i < answer9.Length; i++)
                                    {
                                        serialPortInstance.Write(answer9, i, 1);
                                    }
                                    break;
                                case 0x0D: // UNKNOWN
                                    byte[] answer10 = new byte[] { 0xA5, 0x07, 0x06, 0x9D, 0x10, 0x10, 0x28, 0x14, 0x54 };
                                    serialPortInstance.Write(answer10, 0, answer10.Length);
                                    break;
                                case 0x08: // UNKNOWN (1250?)
                                    byte[] answer11 = new byte[] { 0xA5, 0x04, 0x06, 0xE2, 0x04, 0x6A };
                                    serialPortInstance.Write(answer11, 0, answer11.Length);
                                    break;
                            }
                        }
                        else if (pspdata[0] == 0xA5)
                        {
                            bswpresponse[0] = (byte)serialPortInstance.ReadByte();     // packet length
                            bswpresponse[1] = (byte)serialPortInstance.ReadByte();     // operation code
                            if (bswpresponse[1] == 0x02)                                                  // if packet has no message then byte after the opcode is the checksum
                            {
                                bswpresponse[2] = (byte)serialPortInstance.ReadByte();
                                log(pspdata[0].ToString("X2"));
                                log(BitConverter.ToString(bswpresponse).Replace("-", " "));
                            }
                            else  // packet contains a message
                            {
                                int msgLength = ((int)bswpresponse[0] - 2); // actual msg length (no opcode & csum)
                                while (serialPortInstance.BytesToRead < (int)bswpresponse[0] - 1) { System.Threading.Thread.Sleep(12); }; // wait until buffer has remaining msg and csum (opcode is already read so -1)
                                msg = new byte[msgLength];
                                for (int i = 0; i < msgLength; i++) msg[i] = (byte)serialPortInstance.ReadByte();
                                bswpresponse[2] = (byte)serialPortInstance.ReadByte();
                                log(pspdata[0].ToString("X2") + " " + bswpresponse[0].ToString("X2") + " " + bswpresponse[1].ToString("X2") + " " +
                                    BitConverter.ToString(msg).Replace("-", "") + " " + bswpresponse[2].ToString("X2"));
                            }
                        }
                    }
                }
                catch (InvalidOperationException) { log("COM port is closed!"); }
                catch (Exception e)
                {
                    log
                    ("================================================\n" +
                     e +
                     "================================================");
                    serialPortInstance.Close(); return;
                }
            }
            serialPortInstance.Close();
            log("Service stopped.");
        }

        public static byte[] MixChallenge1(byte version, byte[] challenge)
        {
            byte[] data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

            byte[] secret1 = challenge1_secret[version];
            data[0] = secret1[0];
            data[4] = secret1[1];
            data[8] = secret1[2];
            data[0xC] = secret1[3];
            data[1] = secret1[4];
            data[5] = secret1[5];
            data[9] = secret1[6];
            data[0xD] = secret1[7];
            data[2] = challenge[0];
            data[6] = challenge[1];
            data[0xA] = challenge[2];
            data[0xE] = challenge[3];
            data[3] = challenge[4];
            data[7] = challenge[5];
            data[0xB] = challenge[6];
            data[0xF] = challenge[7];
            debugLog("MixChallenge1: " + BitConverter.ToString(data).Replace("-", " "));
            return data;
        }
        public static byte[] MixChallenge2(byte version, byte[] challenge)
        {
            byte[] data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] secret2 = challenge2_secret[version];
            data[0] = challenge[0];
            data[4] = challenge[1];
            data[8] = challenge[2];
            data[0xC] = challenge[3];
            data[1] = challenge[4];
            data[5] = challenge[5];
            data[9] = challenge[6];
            data[0xD] = challenge[7];
            data[2] = secret2[0];
            data[6] = secret2[1];
            data[0xA] = secret2[2];
            data[0xE] = secret2[3];
            data[3] = secret2[4];
            data[7] = secret2[5];
            data[0xB] = secret2[6];
            data[0xF] = secret2[7];
            debugLog("MixChallenge2: " + BitConverter.ToString(data).Replace("-", " "));
            return data;
        }
        public static byte[] MatrixSwap(byte[] key)
        {
            byte[] temp = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] newmap = new byte[] { 0x00, 0x04, 0x08, 0x0C, 0x01, 0x05, 0x09, 0x0D, 0x02, 0x06, 0x0A, 0x0E, 0x03, 0x07, 0x0B, 0x0F };
            int keyLen = key.Length;
            for (int i = 0; i < keyLen; i++)
            {
                temp[i] = key[newmap[i]];
            }
            debugLog("MatrixSwap: " + BitConverter.ToString(temp).Replace("-", " "));
            return temp;
        }
        public static void generateSysconResponses(byte[] response)
        {
            byte[] screq = response;
            byte version = screq[0];
            if ( !keystore.ContainsKey(screq[0]) )
            {
             KeyLog("================================================\n" +
                    "WARN: Key " + screq[0].ToString("X2") +
                    " not found, your console is probably unsupported. " +
                    "Answering with placeholders.\n" +
                    "================================================");
                response1a = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                response1b = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                response2g = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                return;
            }
           /* else if (screq[0] == 0x08)
            {
                KeyLog("================================================\n" +
                       "WARN: Key " + screq[0].ToString("X2") +
                       " not found. Awaiting fallback to 02, " +
                       "answering with placeholders.\n" +
                       "================================================");
                response1a = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                response1b = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                response2g = new byte[8] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
                return;
            }
            else */
            {
                Random rnd = new Random();
                byte[] req = screq.Skip(1).ToArray();
                byte[] data = MixChallenge1(version, req);
                byte[] challenge1aes = new byte[8];
                challenge1aes = ECBEncryptBytes(MatrixSwap(data), keystore[version]);
                byte[] challenge1a = new byte[8];
                for (int i = 0; i < 8; i++) challenge1a[i] = challenge1aes[i];
                byte[] challenge1baes = ECBEncryptBytes(challenge1a, keystore[version]);
                response1a = challenge1a; // is correct
                rnd.NextBytes(response1b);
                byte[] data2 = MixChallenge2(version, response1b);
                byte[] challenge2aes = ECBEncryptBytes(MatrixSwap(data2), keystore[version]);
                byte[] challenge2 = new byte[8];
                for (int i = 0; i < 8; i++) challenge2[i] = challenge2aes[i];
                debugLog("Expected 0x81 msg: " + BitConverter.ToString(challenge2).Replace("-", ""));
                byte[] response2aes = ECBEncryptBytes(challenge2aes, keystore[version]);
                for (int i = 0; i < 8; i++) response2g[i] = response2aes[i];
            }
            /*
            response1b = challenge1b;
            byte[] data2 = MixChallenge2(version, challenge1b);
            byte[] challenge2aes = new byte[8];
            challenge2aes = ECBEncryptBytes(MatrixSwap(data2), keystore[version]);
            byte[] challenge2 = new byte[8];
            for (int i = 0; i < 8; i++) challenge2[i] = challenge2aes[i];
            byte[] response2aes = new byte[8];
            response2aes = ECBEncryptBytes(challenge2aes, keystore[version]);
            byte[] response2 = new byte[8];
            for (int i = 0; i < 8; i++) response2[i] = response2aes[i];
            response2g = response2;
            */
        }
        private static byte[] ECBEncryptBytes(byte[] clearBytes, byte[] key)
        {
            byte[] encryptedBytes = null;
            // create an AES object
            using (Aes aes = new AesManaged())
            {
                aes.KeySize = 128;
                aes.Key = key;
                aes.Mode = CipherMode.ECB;

                using (MemoryStream ms = new MemoryStream())
                {
                    using (CryptoStream cs = new CryptoStream(ms, aes.CreateEncryptor(), CryptoStreamMode.Write))
                    {
                        cs.Write(clearBytes, 0, clearBytes.Length);
                        cs.Close();
                    }
                    encryptedBytes = ms.ToArray();
                }
            }
            return encryptedBytes;
        }
        private static byte GeneratePacketChecksum(byte[] inputArray) // array with every sigle byte of packet w/o checksum
        {
            int sum = 0;
            for (int i = 0; i < inputArray.Length; i++)
            {
                sum += inputArray[i];
            }
            string hexValue = sum.ToString("X");
            if (hexValue.Length > 2) hexValue = hexValue.Remove(0, hexValue.Length - 2); // trunctate
            byte temp = Convert.ToByte(hexValue.Substring(0, 2), 16);           // convert it to byte    
            byte ret = Convert.ToByte(0xFF - Convert.ToInt32(temp));
            return ret;
        }
        public static byte[] StringToByteArray(string hex)
        {
            return Enumerable.Range(0, hex.Length)
                             .Where(x => x % 2 == 0)
                             .Select(x => Convert.ToByte(hex.Substring(x, 2), 16))
                             .ToArray();
        }
        /*static void WaitForNextByte()
		{
            while (serialPortInstance.BytesToRead < 1) { };
        }*/
    }
}


